import { EntryConfig } from './config';
export declare function getCacheIdentity(entry: EntryConfig): string;
export declare class InvalidCacheError extends Error {
    path: string;
    constructor(message: string, path: string);
    static wrap(e: Error, path: string): InvalidCacheError;
}
export declare function resolveEntry<T>(path: string, generator: () => Promise<T>, cacheIdentity?: string): Promise<T>;
export declare function invalidateEntry(path: string): void;
export declare function invalidateEntries<T>(shouldRemove: (meta: T) => boolean): void;
export declare function storeCache(): void;
export declare function purgeCache(): void;
