"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_1 = __importDefault(require("./node"));
const preset = {
    name: 'next',
    isMatch: ({ hasPackage }) => hasPackage('next'),
    getConfig: (options) => __awaiter(void 0, void 0, void 0, function* () {
        const base = yield node_1.default.getConfig(options);
        const entry = [
            './pages/**/*.{js,jsx,ts,tsx}',
            './src/pages/**/*.{js,jsx,ts,tsx}',
        ];
        return Object.assign(Object.assign({}, base), { entry, ignoreUnused: [
                ...base.ignoreUnused,
                'next',
                'react',
                'react-dom',
            ] });
    }),
};
exports.default = preset;
